#ifndef __AUDIO
#define __AUDIO

#include "console.h"
#include <jack/jack.h>
#include <jack/midiport.h>
#include <iostream>
using namespace std;

typedef jack_default_audio_sample_t sample_t; // this is just float in jack/types.h

struct audio_out {
	
	static const int NUM_CHANNELS = 1;
	static const int SAMPLES_PER_CHANNEL = 2048;
	static const int SAMPLES_PER_BUFFER = NUM_CHANNELS * SAMPLES_PER_CHANNEL;
	int sample_buffer_size;
	sample_t sample_rate;

	jack_client_t *client;

	int lcons, rcons;
	jack_port_t *out_left, *out_right;
	const char **con_left, **con_right;

	jack_port_t *midi_in;
	
	audio_out ();
	~audio_out ();
	
	int open ();
	int close ();

	int start ();
	int stop ();
	void write ();

};

int jack_audio_wanted (jack_nframes_t nsamples, void *arg);
int buffer_size_changed (jack_nframes_t nframes, void *arg);
int sample_rate_changed (jack_nframes_t nframes, void *arg);

console& operator<< (console& c, const audio_out& ao);

#endif
