#ifndef __SCALE_INFO 
#define __SCALE_INFO

#include <string>
#include <map>

struct scale_info {
	
	std::string name;

	float tonic, lo_tonic, hi_tonic;
	int num_octaves;

	std::map <std::string, float> intervals;

	static const int MAX_NOTES = 16; 
	std::string notes [MAX_NOTES];
	int num_ranges;
	int last_range;
		
	
	scale_info () {
		num_octaves = 3;
		num_ranges = 0;
		last_range = -1;
		intervals.clear ();
		load_last ();
	}
	
	~scale_info () {
		save_last ();
	}
	
	void load_last ();
	void save_last ();
	
	void set_tonic (float s);
	bool set_scale (const std::string& n);
	
	bool load_intervals ();
	void save_intervals ();
	
	
};

#endif
