#include <play.h>
#include <iostream>
using namespace std;

play::play (solver *w) {
  init ();
  set_wave (w);
}

void play::init () {
  get_wave = 0;
  x = 1;
  dx = 0;
  left = right = 0;
}

play::play () {
  init ();
}

void play::operator() (float* outl, float* outr, int n, float* wav) {
  // no modulation audio output
	(*get_wave)(x, dx, n, wav);
  for (int i = 0; i < n; ++i) {
		*outl++ += (left * wav[i]);
		*outr++ += (right * wav[i]);
	}
  
}

void play::operator() (float* outl, float* outr, int n, float* wav, float* am, float* fm) {
  // AM and FM modulation in audio output
	(*get_wave)(x, dx, n, fm, wav);
  for (int i = 0; i < n; ++i) {
    *outl++ += ((left + am[i]) * wav[i]);
    *outr++ += ((right + am[i]) * wav[i]);
  }
}
