#include "scalelist.h"
#include "scale_info.h"
#include "console.h"

#include <fstream>
#include <iostream>
using namespace std;

void scale_info::load_last () {
	
	extern string dotdin;
	ifstream file ((dotdin + "last").c_str(), ios::in);
	
	string n = "bhairav";
	float s = 261.62565;
	
	if (file) {
		string ignore;
		file >> ignore >> s;
		file >> ignore >> n;
	} 
	
	set_tonic (s);
	set_scale (n);
	
	cout << "scale: " << n << ", tonic: " << s << eol;
	
}

void scale_info::set_tonic (float s) {
	
	tonic = s;
	lo_tonic = tonic / 2.;
	hi_tonic = tonic * 2.;
		
}

bool scale_info::set_scale (const string& n) {
	
	extern scalelist scalelst;
	scale r; if (scalelst.get (n, r) == false) {
		cons << console::red << "could not load scale: " << n << eol;
		return false;
	}
	
	name = r.name;
	num_ranges = r.num_notes - 1;
	last_range = num_ranges - 1;
	
	tokenizer tz (r.notes);
	for (int i = 0; i < r.num_notes; ++i) {
		tz >> notes[i];
	}

	if (load_intervals() == false) {
		extern map<string, float> INTERVALS;
		intervals = INTERVALS;
	}
	
	cons << "scale is " << console::green << name << eol;
		
	return true;
	
}


void scale_info::save_last () {
	const char* fname = "last";
	extern string dotdin;
	ofstream file ((dotdin + fname).c_str(), ios::out);
	if (file) {
		file << "tonic " << tonic << endl;
		file << "scale " << name << endl;
	}
}



bool scale_info::load_intervals () {
	
	extern string dotdin;
	string filename = dotdin + name + ".intervals";

	ifstream file (filename.c_str(), ios::in);
	if (!file) {
		cout << "couldnt load custom tuning from: " << filename << "; will use defaults." << endl; 
		return false;
	}
	
	string ignore;
	
	int n; 
	file >> ignore >> n;
	
	for (int i = 0; i < n; ++i) {
		string c;
		float f;
		file >> c >> f;
		intervals [c] = f;
	}
	
	return true;
	
	
}

void scale_info::save_intervals () {
	extern string dotdin;
	string filename = dotdin + name + ".intervals";
	ofstream file (filename.c_str(), ios::out);
	if (!file) return;
	
	file << "num_intervals " << intervals.size () << endl;
	for (map<string, float>::iterator i = intervals.begin(), j = intervals.end(); i != j; ++i) {
		pair<string, float> p = *i;
		file << p.first << ' ' << p.second << endl;
	}
	
}
