// General purpose string tokenizer
// based on initial code by Song Ho Ahn (song.ahn@gmail.com)

#include "tokenizer.h"
#include <cstdlib>

#include <iostream>
using namespace std;

void tokenizer::init_cur () {
	if (buffer.length()) cur = 0; else cur = -1;
}

tokenizer::tokenizer() {
	str ("");
	del (DEFAULT_DELIMITER);
}

tokenizer::tokenizer(const std::string& s, const std::string& d) {
	str (s);
	del (d);
}

void tokenizer::set (const std::string& s, const std::string& d)
{
		str (s);
		del (d);
}

void tokenizer::str (const std::string& s)
{
    buffer = s;
    blen = buffer.length ();
    init_cur ();
}

void tokenizer::del (const std::string& d)
{
    delimiter = d;
    dlen = delimiter.length ();
}

tokenizer& tokenizer::operator>> (std::string& s) {
	token = "";
	if (buffer.length() < 1) {
		s = token;
	} else {
		skip_ws ();
		while ((cur < blen) && !isdelim (buffer[cur])) {
			token += buffer[cur];
			++cur;
		}
		s = token;
	}
	return *this;
}

tokenizer& tokenizer::operator>> (float& f) {
	string s; *this >> s;
	f = atof (s.c_str());
	return *this;
}

tokenizer& tokenizer::operator>> (int& i) {
	string s; *this >> s;
	i = atoi (s.c_str());
	return *this;
}

tokenizer& tokenizer::operator>> (char& c) {
	string s; *this >> s;
	if (s.length()) c = s[0];
	return *this;
}


void tokenizer::skip_ws () {
	while (cur < blen) if (!isdelim (buffer[cur])) break; else ++cur;
}

bool tokenizer::isdelim (char c) {
	for (int i = 0; i < dlen; ++i) {
		if (delimiter[i] == c) return true;
	}
	return false;
}
